// Guilherme A. Pinto, OBI-2018, sequencia

import java.util.*;
import java.io.*;
import java.lang.*;

public class sequencia_nh_java {
    
    public static void main(String[] args) throws IOException {
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter writer = new PrintWriter(System.out);
	
        String line = in.readLine();    
        StringTokenizer tokenizer = new StringTokenizer(line," ");
        int N = Integer.parseInt(tokenizer.nextToken());
        int L = Integer.parseInt(tokenizer.nextToken());
        int H = Integer.parseInt(tokenizer.nextToken());

	int s[] = new int[N];
	int m[] = new int[N];
	
	line = in.readLine();
	tokenizer = new StringTokenizer(line," ");
	for ( int i = 0; i < N; i++ )
	    s[i] = Integer.parseInt(tokenizer.nextToken());

	line = in.readLine();
	tokenizer = new StringTokenizer(line," ");
	for ( int i = 0; i < N; i++ )
	    m[i] = Integer.parseInt(tokenizer.nextToken());
	
	int MIN = Integer.MIN_VALUE;
	int MAXH = 20;

	int dp[][] = new int[N][MAXH+1];

	for ( int i = 0; i < N; i++ )
	    for ( int j = 0; j < MAXH+1; j++ )
		dp[i][j] = MIN;
	
	int res = MIN;

	// dp[i][k] = (soma do) sufixo da sequencia s_0,...,s_i, de soma maxima,
	//            contendo exatamente k elementos marcados
	
	// base
	if ( m[0] == 1 ){ // marcado
	    dp[0][0] = 0;
	    dp[0][1] = s[0];
	} else { // nao marcado
	    dp[0][0] = Math.max( 0, s[0] );
	}

	// recursao
	for( int i = 1; i < N; i++ ){
	    for( int k = 0; k <= H; k++ ){
		if ( m[i] == 1 ) { // marcado
		    if ( k == 0 ) dp[i][0] = 0;
		    if ( k > 0 && dp[i-1][k-1] > MIN ) dp[i][k] = dp[i-1][k-1]+s[i];
		} else { // nao marcado
		    if ( k == 0 ) dp[i][0] = Math.max( 0, dp[i-1][0]+s[i] );
		    if ( k > 0 && dp[i-1][k] > MIN ) dp[i][k] = dp[i-1][k]+s[i];
		}
	    }
	    
	    // maximo global
	    for( int k = L; k <= H; k++ )
		if ( dp[i][k] > MIN )
		    res = Math.max( res, dp[i][k] );
	}
	
	writer.println( res );
	writer.close();
    }
}
